// KEKS/CM -- KEKS-encoded cryptographic messages
// Copyright (C) 2024-2025 Sergey Matveev <stargrave@stargrave.org>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation, version 3 of the License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program.  If not, see <http://www.gnu.org/licenses/>.

package slhdsa

import (
	"go.cypherpunks.su/keks/cm/sign/slhdsa/circl"
)

func Verify(algo string, pub, signed, signature []byte) (valid bool, err error) {
	var pk circl.PublicKey
	pk.ID = circl.SHAKE_256s
	err = pk.UnmarshalBinary(pub)
	if err != nil {
		return
	}
	valid = circl.Verify(&pk, circl.NewMessage(signed), signature, []byte(algo))
	return
}

func VerifyPrehash(algo string, pub, hsh, signature []byte) (valid bool, err error) {
	return Verify(algo, pub, hsh, signature)
}
